open Tree
open Reader
   
exception Error of string

let rec parse_S () =
  match lookahead () with
  | Ch 'i' -> begin (* S -> i *)
      eat (Ch 'i');
      Node("S",[Leaf 'i'])
    end
  | Ch '[' -> begin (* S -> [S+S] *)
      eat (Ch '[');
      let x1 = parse_S () in
      eat (Ch '+');
      let x2 = parse_S () in
      eat (Ch ']');
      Node("S",[Leaf '[';x1;Leaf '+'; x2; Leaf ']'])
    end
  | t -> raise (Error (Printf.sprintf
                         "parsing S: unexpected %s"
                         (Reader.string_of_token t)))
       
let parse () = parse_S ()
                 
